<?php
/**
* 
* ARI Smart Content system Joomla! plugin
* Copyright (c) 2009 ARI Soft. http://www.ari-soft.com
* Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html 
* 
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemAriSmartContent extends JPlugin
{
	var $_isComponentInstalled = null;
	
	function plgSystemAriSmartContent(&$subject, $config)
	{
		parent::__construct($subject, $config); 
	}
	
	function onAfterRender()
	{
		global $option;
 
		$mainframe =& JFactory::getApplication();
		if ($mainframe->isAdmin() || !$this->_isSCInstalled()) return ;

		$params = $this->params;
		$allPages = $params->get('allComponents', 'no');
		if ($allPages != 'yes')
		{
			if (empty($option)) return ;

			$components = trim($this->params->get('components', ''));
			$components = explode("\n", $components);
			$components = array_map('trim', $components);
			
			if (!in_array($option, $components)) return ;
		}
		
		$this->_load();
		
		$includesManager = new AriDocumentIncludesManager();
		
		$bot = new AriSmartContentMambot();
		$pParams = null;
		$content = JResponse::getBody();
		$bot->processContent(true, $content, $pParams);

		JResponse::setBody($content);

		$includes = $includesManager->getDifferences();
		AriDocumentHelper::addCustomTagsToDocument($includes);
	}
	
	function _load()
	{
		static $loaded = false;
		if ($loaded) return ;
		
		require_once JPATH_SITE . '/administrator/components/com_arismartcontent/kernel/class.AriKernel.php';
		
		AriKernel::import('Joomla.JoomlaBridge');
		AriKernel::import('Constants.ClassConstants');
		AriKernel::import('Constants.ConstantsManager');
		AriKernel::import('GlobalPrefs.GlobalPrefs');
		AriKernel::import('Components.AriSmartContent.AriSmartContent');
		AriKernel::import('Components.AriSmartContent.Mambot.AriSmartContentMambot');
		AriKernel::import('Web.Utils.WebHelper');
		AriKernel::import('Web.TaskManager');
		AriKernel::import('Web.Response');
		AriKernel::import('Controllers.ControllerBase');
		AriKernel::import('Mambot.MambotBase');
		AriKernel::import('Web.JSON.JSONHelper');
		AriKernel::import('Document.DocumentHelper');
		AriKernel::import('Document.DocumentIncludesManager');
		
		$scComp =& AriSmartContentComponent::instance();
		$scComp->init();
		
		$loaded = true;
	}
	
	function _isSCInstalled()
	{
		if (is_null($this->_isComponentInstalled))
		{
			$path = JPATH_SITE;
			$adminBasePath = $path . '/administrator/components/com_arismartcontent';
			
			$this->_isComponentInstalled = @file_exists($adminBasePath); 
		}

		return $this->_isComponentInstalled; 
	}
}
?>